# List Tasks

> Source: https://truto.one/docs/api-reference/unified-crm-api/tasks/list/

`GET /unified/crm/tasks`

Resource: **Tasks** · API: **Unified CRM API**

## Supported integrations

Accelo, Attio, Capsule, Close, Copper, Freshsales, Highlevel, HubSpot, Insightly, Keap, OnePageCRM, Outreach, Pipedrive, Planhat, Salesflare, Salesforce, Teamleader, Wix, Zendesk Sell, Zoho CRM

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`owner`** _(object)_
  The task's owner
- **`created_at`** _(string)_
  The date and time of the task's creation
- **`updated_at`** _(string)_
  The date and time of the task's last update
- **`due_date`** _(string)_
  The date and time of the task's due date
- **`completed_at`** _(string)_
  The date and time of the task's completion
- **`status`** _(string)_
  The task's status
  Allowed: `blocked`, `closed`, `complete`, `completed`, `deferred`, `incomplete`, `not_started`, `open`, `pending`
- **`account`** _(object)_
  The task's account
- **`sort_by`** _(enum)_
  Allowed: `completed_at`, `created_at`, `due_date`, `status`, `subject`, `updated_at`
- **`workspace`** _(array<object>)_
- **`contact`** _(object)_
  The task's contact
- **`search_term`** _(unknown)_
- **`subject`** _(string)_
  The task's subject
- **`content`** _(string)_
  The task's content
- **`opportunity`** _(array<object>)_
  The task's opportunity
- **`lead`** _(array<object>)_
  The task's lead

## Response body

- **`result`** _(array<object>)_
  List of Tasks
  - **`id`** _(string, required)_
    The task's unique identifier
  - **`subject`** _(string)_
    The task's subject
  - **`content`** _(string)_
    The task's content
  - **`type`** _(object)_
    The task's type
    - **`id`** _(string)_
      The type's unique identifier
    - **`name`** _(string)_
      The type's name
  - **`owner`** _(object)_
    The task's owner
    - **`id`** _(string)_
      The owner's unique identifier
    - **`name`** _(string)_
      The owner's name
  - **`account`** _(object)_
    The task's account
    - **`id`** _(string)_
      The account's unique identifier
  - **`contact`** _(array<object>)_
    The task's contact
    - **`id`** _(string)_
      The contact's unique identifier
    - **`name`** _(string)_
      The contact's name
  - **`opportunity`** _(array<object>)_
    The task's opportunity
    - **`id`** _(string)_
      The opportunity's unique identifier
    - **`name`** _(string)_
      The opportunity's name
  - **`lead`** _(array<object>)_
    The task's lead
    - **`id`** _(string)_
      The lead's unique identifier
    - **`name`** _(string)_
      The lead's name
  - **`completed_at`** _(string)_
    The date and time of the task's completion
  - **`due_date`** _(string)_
    The date and time of the task's due date
  - **`status`** _(string)_
    The task's status
    Allowed: `open`, `completed`
  - **`created_at`** _(string)_
    The date and time of the task's creation
  - **`updated_at`** _(string)_
    The date and time of the task's last update
  - **`etag`** _(string)_
    The unique identifier for the specific version of the resource.
  - **`urls`** _(array<object>)_
    The task's urls
    - **`url`** _(string)_
      The task's URL
    - **`type`** _(string)_
      The task's URL type
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/crm/tasks?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/crm/tasks?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/crm/tasks"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'crm',
  'tasks',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "crm",
        "tasks",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
